#include <xc.h>

void System_Initialize(void)
{
    TRIS = 0x04;
    GPIO = 0x00;
    ADCON0 = 0b01101001;
    CM1CON0 = 0xF7;
    
    OPTION = 0xC3;
    
}

unsigned char ADC_GetConversion(void)
{
    ADCON0bits.GO_nDONE = 1;
    while(ADCON0bits.GO_nDONE);
    
    return ADRES;
}

void main(void)
{
    unsigned short cnt = 0;
    unsigned char ADC_Value;
    unsigned char prevTMR0, currTMR0;
    
    System_Initialize();
    
    prevTMR0 = TMR0;
    while(1)
    {
        ADC_Value = ADC_GetConversion();
        if(ADC_Value < 0x80)
        {
            GPIObits.GP5 = 1;
        }
        else
        {
            GPIObits.GP5 = 0;
        }
        
        currTMR0 = TMR0;
        if(prevTMR0 > currTMR0)
        {
            cnt++;
            
            if(cnt > 217)
            {
                cnt = 0;
                if(GPIObits.GP4)
                {
                    GPIObits.GP4 = 0;
                }
                else
                {
                    GPIObits.GP4 = 1;
                }
            }
        }
        prevTMR0 = currTMR0;
    }
}
